<?php
/**
 * Integration with Venistar
 * Copyright (C) 2019 
 * 
 * This file is part of FiloBlu/Venistar.
 * 
 * FiloBlu/Venistar is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

namespace FiloBlu\Venistar\Helper;

use Magento\Framework\App\Helper\AbstractHelper;

class Api extends AbstractHelper
{

    /**
     * @param \Magento\Framework\App\Helper\Context $context
     */
    public function __construct(
        \Magento\Framework\App\Helper\Context $context
    ) {
        parent::__construct($context);
    }

    /**
     * @param $order_entity_id
     * @param $token
     * @return bool|string
     */
    public function getOrderDataByApi($order_entity_id,$token){
        $secure_admin_base_url = $this->scopeConfig->getValue("web/secure/base_url");
        $secure_admin_base_url = rtrim($secure_admin_base_url,'/');
        $api_url = "{$secure_admin_base_url}/rest/all/V1/orders/{$order_entity_id}";

        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL, $api_url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'GET');
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);

        $headers = array();
        $headers[] = 'Accept: application/json';
        $headers[] = 'Authorization: Bearer '.$token;
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

        $result = curl_exec($ch);
        if (curl_errno($ch)) {
            //echo 'Error:' . curl_error($ch);
        }
        curl_close($ch);
        if (!$result){
            return false;
        }
        $decoded = json_decode($result,true);
        if (isset($decoded['increment_id'])){
            // This is an order json?
            return $result;
        }
        return false;
    }


}
